
# preparing tarball:
# git clone https://github.com/patjak/facetimehd.git
# git clone -b master https://github.com/patjak/facetimehd.git

%global		module	hd
%global		pname	facetime%{module}

Name:		dkms-facetimehd
Version:	0.6.8
Release:	%mkrel 1
Source0:	%{pname}-%{version}.tar.xz
# too old
###Patch0:		facetimehd-makefile-firmware-inst-5.5+.patch
Patch0:     facetimehd-makefile-5.18.patch
# now in sources
#Patch1:		facetimehd-kernel-5.6+++fthd_drv.c.patch
# new on kernel 5.7--
#Patch2:		facetimehd-kernel-upto-5.7.+.patch
License:	GPLv2
Group:		System/Kernel and hardware
URL:		https://github.com/patjak/facetimehd
Summary:	dkms driver for Webcam in Macbooks (Broadcom 1570 PCIe webcam)
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot
Provides:	%{name}-%{version}
Requires: 	kernel
Requires:   gcc >= 9.2.0
Requires(post):		dkms
Requires(preun):	dkms

Obsoletes:	%{name} <= %{version} 

%description -n %{name}
Linux driver and firmware for the Facetime HD (Broadcom 1570) PCIe webcam
found in recent Macbooks.
Note that this module requires Linux kernel 4.4 or later
(it is currently unknown which earlier kernels it will work with).
According to Apple the following models contain a Facetime HD camera
and should be compatible with this driver:
iMac (21,5", since mid 2011)
iMac (27", since mid 2011)
MacBook Air (since mid 2011)
MacBook Pro (15", since early 2011)
MacBook Pro (17", since early 2011)
MacBook Pro (13", since early 2011)
Thunderbolt display

Revert to discrete frame sizes and frame intervals Skype and other applications
don't support stepwise frame sizes and frame intervals.
Instead they try to handle them as discrete devices which fails.
It seems they will never fix this so instead we reduce our functionality
to just support the discrete type.


%prep
%setup -qn %{pname}-%{version}
find -type f -exec chmod 0644 {} \;

%autopatch -p1

%install
%__rm -rf %{buildroot}
%__install -dm755 %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__cp -a ./* %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__rm -f %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/{README.md}
###%__install -Dm644 %{S:2} %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/patches/facetimehd-kernel-5.4.0.patch
%__cat <<EOF > %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/dkms.conf
PACKAGE_NAME=%{pname}
PACKAGE_VERSION=%{version}-%{release}
BUILT_MODULE_NAME[0]="%{pname}"
BUILT_MODULE_LOCATION[0]="./"
DEST_MODULE_LOCATION[0]="/kernel/3rdparty/%{pname}"
MAKE="export IGNORE_CC_MISMATCH=1; 'make' clean KSRC=\${kernel_source_dir} SKIP_STACK_VALIDATION=1 all"
AUTOINSTALL="yes"
MODULES_CONF[0]="blacklist bdc_pci"
CLEAN="make clean"
EOF


%post -n %{name}
rmmod bdc_pci >/dev/null 2>&1
## also clean olders in /extra... there was only modules, not a directory
find ./lib/modules/*/extra -type f -name "facetimehd.ko.xz" -exec rm {} \; >/dev/null 2>&1

/usr/sbin/dkms --rpm_safe_upgrade add -m %{pname} -v %{version}-%{release} &&
/usr/sbin/dkms --rpm_safe_upgrade build -m %{pname} -v %{version}-%{release} &&
/usr/sbin/dkms --rpm_safe_upgrade install -m %{pname} -v %{version}-%{release} || :

/sbin/modprobe %{pname} >/dev/null 2>&1


%preun -n %{name}
/sbin/rmmod %{pname} >/dev/null 2>&1
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{pname} -v %{version}-%{release} --all || :
## remove module-destdir just if it empty after dkms remove,(user's only deinstall after testing)... ##
## so prevent we not have empty folders in kernel-tree for next mklivecd ##
if [ ! -f /lib/modules/*/kernel/3rdparty/%{pname}/* ]; then
rm -r /lib/modules/*/kernel/3rdparty/%{pname} >/dev/null 2>&1
fi
## also clean olders in /extra... there was only modules, not a directory
find ./lib/modules/*/* -type f -name "facetimehd.ko.xz" -exec rm {} \; >/dev/null 2>&1


%clean
%__rm -rf %{buildroot}

%files -n %{name}
%defattr(-,root,root)
%doc README.md
%{_usrsrc}/%{pname}-%{version}-%{release}/*


%changelog
* Tue Feb 13 2024 onkelho <oh.quait at gmail.com> - 0.6.8-1quait2024
- new version released 2 weeks ago

* Thu Jun 16 2022 onkelho <oh.quait at gmail.com> - 0.5.18-4pclos2022
- rebuild

* Tue Jun 14 2022 onkelho <oh.quait at gmail.com> - 0.5.18-3pclos2022
- rebuild - change to patch0:facetimehd-makefile-5.18.patch

* Sat Jun 11 2022 onkelho <oh.quait at gmail.com> - 0.5.18-2pclos2022
- rebuild - fix makefile patching and relevants

* Wed Jun 08 2022 onkelho <oh.quait at gmail.com> - 0.5.18-1pclos2022
- new version released

* Mon Jan 31 2022 onkelho <oh.quait at gmail.com> - 0.5.7-2pclos2022
- updates kerv-5.17
- add export IGNORE_CC_MISMATCH=1;

* Thu Nov 25 2021 onkelho <oh.quait at gmail.com> - 0.5.7-1pclos2021
- new version released
- add Specify module device table 16.Nov
- add Apply SPDX license identifiers and provice a LICENSE file 11.Aug

* Wed Jun 08 2020 onkelho <oh.quait at gmail.com> - 0.1-12pclos2020
- rebuild patch2 added support for kernel-5.7...

* Thu May 30 2020 onkelho <oh.quait at gmail.com> - 0.1-11pclos2020
- rebuild 
- 22May :: Revert to discrete frame sizes and frame intervals 
- Skype and other applications don't support stepwise frame sizes and
- frame intervals. Instead they try to handle them as discrete devices
- which fails. It seems they will never fix this so instead we reduce our
- functionality to just support the discrete type.
- Replace ioremap_nocache() with ioremap()
- ioremap_nocache() got removed from upstream because ioremap() always
- gave "nocache". Use ioremap() instead.
- Fixes: 4bdc0d676a643140bdf17dbf7eafedee3d496a3c
- remove ioremap_nocache and devm_ioremap_nocache

* Thu Apr 09 2020 onkelho <oh.quait at gmail.com> - 0.1-10pclos2020
- rebuild -add patch2 -fix kernel-5.6+++

* Wed Feb 05 2020 onkelho <oh.quait at gmail.com> - 0.1-9pclos2020
- rebuild -- rewrite patch0 (S2 moved to patch0), patching before dkms-compile
- remove patch1 facetimehd-kernel-5.4.0.patch, now in sourcecode 

* Mon Dec 02 2019 onkelho <oh.quait at gmail.com> - 0.1-8pclos2019
- rebuild --add facetimehd-kernel-5.4.0.patch as Source2

* Mon May 27 2019 onkelho <oh.quait at gmail.com> - 0.1-6pclos2019
- rebuild

* Thu Nov 08 2018 onkelho <oh.quait at gmail.com> - 0.1-5pclos2018
- rebuild -- add remove empty module-destdir after dkms remove

* Mon Jun 25 2018 onkelho <oh.quait at gmail.com> 0.1-4pclos2017
- rebuild

* Mon Nov 20 2017 onkelho <oh.quait at gmail.com> 0.1-2pclos2017
- first build from https://github.com/patjak/bcwc_pcie
- also install firmware (prebuilded reverse engineered)
- if you would make it self, you need install
- - xar-1.6.1-1pclos2017, cpio-2.12-2pclos2017
- - and pbzx-stream-parser-20140623-1pclos2017
- installed and try make in the firmware-directory
